## ncl 6.6.2.dfsg.1

=== install/install/Makefile ===
ROOT_DIR = /ptmp/haley
INS_DIR	= $(ROOT_DIR)/INSTALL
SRC_TAR	= $(ROOT_DIR)/SRC.TAR

TARGETS		= HPUX_HP9000_8xx HPUX_HP9000_7xx AIX_32_RS6000 AIX_64_RS6000 \
		Solaris_sun4 ULTRIX_RISC IRIX_n32_IP IRIX_64_IP LINUX_alpha \
		OSF1_alpha UNICOS_YMP UNICOS_J90 UNICOS_C90 LINUX_PC LINUX_IA64 \
		Solaris_PC CYGWIN_PC DARWIN_MAC

SHELL		= /bin/sh

all::	dirs

all::
	@/bin/rm -f var/TOC
all::
	@-for name in $(TARGETS); do \
		cp $(ROOT_DIR)/$$name/sizes var/sizes.$$name; \
		cp $(ROOT_DIR)/$$name/version var/version.$$name; \
	done

dirs::
	@if (test ! -d $(INS_DIR)) then mkdir $(INS_DIR); else continue; fi
	@if (test ! -d $(INS_DIR) || test ! -w $(INS_DIR)) then \
	echo "Installation Error - $(INS_DIR) is not writeable"; exit 1; \
	fi
	@/bin/rm -fr $(INS_DIR)/*

install::	all
	tar -cf - . | (cd $(ROOT_DIR)/INSTALL; tar -xf -)

clean::
	/bin/rm -f var/*

=== debian/changelog ===
ncl (6.6.2.dfsg.1-8) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * Team upload.
  * d/patches/gcc14.patch: partial fix FTBFS with gcc-14

  [ Alastair McKinstry ]
  * Further fixed to FTBFS. Closes: #1075308

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 13 Aug 2024 16:07:51 +0100

ncl (6.6.2.dfsg.1-7) unstable; urgency=medium

  * Set Debian Science Maint. as maintainer
  * Add loongarch64 support. Closes: #1059008
  * Move from pkg-config to pkgconf
  * Fix broken vcs url
  * Standards-Version: 4.7.0; no changes required
  * hdf4-migration.patch for hdf 4.3.0. Closes: #1069845

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 27 Apr 2024 15:14:28 +0100

ncl (6.6.2.dfsg.1-6) unstable; urgency=medium

  * hdf4.3.0 patch was not applied; redo. Closes: #1066408

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 09 Apr 2024 15:17:32 +0100

ncl (6.6.2.dfsg.1-5) unstable; urgency=medium

  [ Alastair McKinstry ]
  * Build with Option qa=-bug to cope with ancient lack of prototypes
    Closes: #1066408

  [ Bas Couwenberg ]
  * Rebuild with HDF 4.3.0. Closes: #1068387

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 04 Apr 2024 13:15:26 +0200

ncl (6.6.2.dfsg.1-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063163

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 22:02:00 +0000

ncl (6.6.2.dfsg.1-4) unstable; urgency=medium

  * Rebuild against libg2c-dev (>= 1.8.0) for transition

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 16 Jan 2024 12:33:07 +0000

ncl (6.6.2.dfsg.1-3) unstable; urgency=medium

  * Drop reference to libgrib2c-dev : now libg2c-dev
  * Drop Build Dep on altas; now obsolete. Closes: #1056679
  * Switch  from ttf-bitstream-vera to fonts-dejavu-core. Closes: #998270

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 26 Nov 2023 11:23:02 +0000

ncl (6.6.2.dfsg.1-2) unstable; urgency=medium

  * Transition B-D libfreetype6-dev to libfreetype-dev
  * Standards-Version: 4.6.2

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 16 Jul 2023 15:50:41 +0100

ncl (6.6.2.dfsg.1-1) unstable; urgency=medium

  * DSFG-version, without ncarview/src/lib/libictrans/lex.yy_linux.c
    Closes: #1029035
  * Drop ictrans; no longer builds

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 17 Jan 2023 13:01:49 +0000

ncl (6.6.2-12) unstable; urgency=medium

  * Move from libgrib2c-dev to libg2c-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 11 May 2022 20:05:27 +0100

ncl (6.6.2-11) unstable; urgency=medium

  * Fix FTBFS on riscv64, thanks to Bo YU. Closes: #1010056

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 23 Apr 2022 15:05:17 +0100

ncl (6.6.2-10) unstable; urgency=medium

  * iftran-fix.patch: Hack to pre-generate Fortran code via Iftran to avoid
    Iftran gcc bug on i386. Closes: #993992

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 15 Sep 2021 15:43:18 +0100

ncl (6.6.2-9) unstable; urgency=medium

  * Fix proj.patch: Force use of /usr/include/proj.h in TransformCoordinate.c
    to avoid version in hdf-eos5 include path

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 09 Sep 2021 19:07:05 +0100

ncl (6.6.2-8) unstable; urgency=medium

  * Add proj 8.0 support
  * Set gfortran flags for >=9. Closes: #984251
  * Standards-Version: 4.6.0

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 22 Feb 2021 19:37:11 +0000

=== debian/control ===
Source: ncl
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), 
 flex, 
 bison, 
 gfortran | fortran-compiler, 
 zlib1g-dev, 
 libbz2-dev, 
 libxt-dev,
 libxaw7-dev, libxmu-headers, libcairo2-dev, libjpeg-dev, libpng-dev,
 pkgconf,
 fontconfig, 
 libfontconfig1-dev, 
 libfreetype-dev, 
 libexpat1-dev,
 libpixman-1-dev,  
 libcurl4-gnutls-dev | libcurl-dev,  
 libgdal-dev,
 libnetcdf-dev, 
 libnetcdff-dev, 
 libudunits2-dev, 
 libmotif-dev,
 liblapack-dev | libopenblas-dev | liblapack.so,
 libblas-dev | libopenblas-dev | libblas.so,
 libg2c-dev (>= 1.8.0~1), 
 libsphere-dev (>= 3.3~a1), 
 libhdf4-alt-dev, 
 libhdfeos-dev,
 libgctp-dev, 
 libhe5-hdfeos-dev,
 tcsh | csh | c-shell,
 libhdf5-dev | libhdf5-mpi-dev,
 libproj-dev, 
 libaec-dev,
 libfl-dev, 
 libgsl-dev
Standards-Version: 4.7.0
Homepage: https://www.ncl.ucar.edu/
Vcs-Browser: https://salsa.debian.org/science-team/ncl.git
Vcs-Git: https://salsa.debian.org/science-team/ncl.git -b debian/latest

Package: ncl-ncarg
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}, tcsh | csh | c-shell
Description: NCAR Command Language and NCAR graphics
 The NCAR Command Language (NCL) is a free interpreted language designed
 specifically for scientific data processing and visualization. NCL has robust
 file input and output. It can read and write netCDF-3, netCDF-4 classic
 HDF4, HDF5, binary, and ASCII data, and read HDF-EOS2, GRIB1 and
 GRIB2. The graphics are world class and highly customizable.
 .
 The software comes with a couple of useful command line tools:
 * ncl_filedump - prints the contents of supported files (netCDF, HDF,
   GRIB1, GRIB2, HDF-EOS2, and CCM History Tape)
 * ncl_convert2nc - converts one or more GRIB1, GRIB2, HDF and/or HDF-EOS
   iles to netCDF formatted files.

Package: libncarg0t64
Provides: ${t64:Provides}
Replaces: libncarg0
Breaks: libncarg0 (<< ${source:Version})
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libudunits2-0, fonts-dejavu-core, fonts-lyx, libncarg-data, tcsh | csh | c-shell
Recommends: libncarg-bin, pkgconf
Multi-Arch: same
Description: NCAR command-language library
 NCAR Command Language library used by NCAR binaries and tools.

Package: libncarg-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libncarg0t64 (= ${binary:Version} ), libudunits2-dev,
 libsphere-dev, libhdf4-alt-dev, 
 ncl-ncarg, ksh | mksh | pdksh | zsh
Multi-Arch: same
Description: Development files for the NCAR command language library
 ncarg is the NCAR command-language. 

Package: libncarg-bin
Architecture: any
Depends: ${misc:Depends}, libncarg-dev (= ${binary:Version} ), ${shlibs:Depends}, tcsh | csh | c-shell
Multi-Arch: foreign
Description: NCAR command-language library - development tools
 This package provides development tools for developing applications of the 
 NCARG command library, such as wrappers for compilation of NCL executables.

Package: libncarg-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ksh | mksh | pdksh | zsh
Description: NCAR command-language library - Data
 NCAR Command Language library used by NCAR. This package contains data such
 as colormaps, fonts and map data that is used by the ncarg library.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = qa=-bug

# The magic debhelper  rule
%:
	dh $@ 

DESTDIR:=$(CURDIR)/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
UPSTREAM_VERSION = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

DO_FLANG:=$(if $(wildcard /usr/bin/flang),true, false)

# See #984251. Don't set flags for gfortran-9, only 10+
GF_FLAGS:=$(if $(filter $(shell readlink /usr/bin/gfortran), gfortran-9), , \
                 -fallow-invalid-boz -fallow-argument-mismatch )

# For the config file. Done this way to pull in stuff from hardening, etc.
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) 
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
# LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
LDFLAGS:= 
FFLAGS=$(shell dpkg-buildflags --get FFLAGS) $(GF_FLAGS)
CC ?= cc


# FC set to f77 by default in make
# Read default compiler name unless FC is actually set
ifeq ($(F77),f77)
  F77:=$(shell basename $(shell readlink /etc/alternatives/f77))
endif

ifneq ($(filter flang,$(F77)),)
FFLAGS:=$(shell dpkg-buildflags --get FFLAGS |  sed -e 's/-g //')
CTOFLIBS:= -lm
endif
ifneq ($(filter gfortran,$(F77)),)
# export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
FFLAGS:=$(FFLAGS) -fno-second-underscore -fno-range-check
CTOFLIBS:= -lgfortran -lm
endif

ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial/libhdf5.so),)
  CFLAGS += -I/usr/include/hdf5/serial
  export HDF5_LDFLAGS := -Wl,-L/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial
endif

export LD_LIBRARY_PATH=$(CURDIR)/shared:$(LIBDIR)/fortran/$(F77):$(LIBDIR)/libfakeroot

# We built it twice: first shared, to get the shared libraries (with -fpic -fPIC)
# then static, for execution speed.

LIBS:= \
	libNGcgm.so  libNGctrans.so   libNGgksPDF.so  libNGgksX.so     libNGlluC.so  libNGmisc2.so  libNGncl.so \
	libNGcn.so   libNGff.so       libNGgksPS.so   libNGhlu.so      libNGllu.so   libNGmisc.so   libNGnfp.so \
	libNGc.so    libNGgksCTXT.so  libNGgks.so     libNGictrans.so  libNGmath.so  libNGmp.so     libNGras.so \
	libfftpack5_dp.so  libNGnfpfort.so 

# Add extra libs to ensure all shared libs link
EXTRA_LIBS:= -lpng -lz -lX11 -lcairo -lsphere-$(F77)

# This done here to avoid subsitution bug on broken ymake buildsystem
INCS="-I/usr/include/freetype2 -I/usr/include/gdal  -I/usr/include/hdf-eos5 -I/usr/include/hdf -I/usr/include/${DEB_HOST_MULTIARCH}/hdf -I/usr/include/mpi"

override_dh_auto_configure:
	sed -e 's,@LIBDIR@,$(LIBDIR),' \
	    -e 's/@PREFIX@/\/usr/' \
	    -e 's/@VERSION@/$(UPSTREAM_VERSION)/' \
	< debian/ncarg.pc.in > ncarg.pc
	sed -e 's%@CC@%${CC}%' \
	    -e 's%@FC@%${FC}%' \
	    -e 's%@LD@%${CC}%' \
	    -e 's%@CFLAGS@%${CFLAGS}%' \
	    -e 's%@FFLAGS@%${FFLAGS}%' \
	    -e 's%@CTOFLIBS@%${CTOFLIBS}%' \
	    -e 's%@CPPFLAGS@%${CPPFLAGS}%' \
	    -e 's%@LDFLAGS@%${LDFLAGS}%' \
	    -e 's%@DESTDIR@%${DESTDIR}%' \
	< debian/Site.local.shared.in > config/Site.local.shared
	sed -e 's%@CC@%${CC}%' \
	    -e 's%@FC@%${FC}%' \
	    -e 's%@LD@%${CC}%' \
	    -e 's%@CFLAGS@%${CFLAGS}%' \
	    -e 's%@FFLAGS@%${FFLAGS}%' \
	    -e 's%@CTOFLIBS@%${CTOFLIBS}%' \
	    -e 's%@CPPFLAGS@%${CPPFLAGS}%' \
	    -e 's%@LDFLAGS@%${LDFLAGS}%' \
	    -e 's%@DESTDIR@%${DESTDIR}%' \
	< debian/Site.local.static.in > config/Site.local.static
	sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%' \
	< config/Project > config/Project.post
	mv config/Project.post config/Project 

override_dh_auto_build:
	cp config/Site.local.shared config/Site.local
	cp debian/LINUX.DEBIAN.$(F77) config/LINUX
	ln -sf LINUX config/DEBIAN
	# regenerate lex file; shipped was non-dfsg
	( cd ./ncarview/src/lib/libictrans ; flex -o lex.yy_linux.c lex.l )
	echo 'n' | ./Configure -v
	$(MAKE) Makefiles includes depend
	# Static libraries need to be built first
	# Add symlink for non-Linux archs
	cp config/Site.local.static config/Site.local
	echo 'n' | ./Configure -v
	$(MAKE) Makefiles includes depend
	for d in common external ngmath/src/lib ncarg2d/src/libncarg_gks ncarg2d/src/libncarg ncarg2d/src/liboptional  ncarview ni/src/lib ; do \
		$(MAKE) -C $$d install INCSEARCH=${INCS} INC_SEARCH=${INCS} ; done
	LD_LIBRARY_PATH=$(DESTDIR)/lib:$(LIBDIR)/fortran/$(F77) $(MAKE) install INCSEARCH=${INCS} INC_SEARCH=${INCS} 
	# Install them safely in $(DESTDIR) as originals will be removed making shared libs
	mkdir -p $(DESTDIR)/staticlibs
	mv $(DESTDIR)/lib/*.a $(DESTDIR)/staticlibs
	$(MAKE) clean
	find . -name '*.[o]' -delete
	# Shared libraries next, in the right order.
	cp config/Site.local.shared config/Site.local
	echo 'n' | ./Configure -v
	$(MAKE) Makefiles includes depend
	for d in common external ngmath/src/lib ncarg2d/src/libncarg_gks ncarg2d/src/libncarg ncarg2d/src/liboptional  ncarview ni/src/lib/nfpfort  ni/src/lib ; do \
		LD_LIBRARY_PATH=$(DESTDIR)/lib:$(LIBDIR)/fortran/$(F77):$(CURDIR)/shared $(MAKE) -C $$d install \
			DEV_SYS_LIBS=$(EXTRA_LIBS)   INCSEARCH=${INCS} INC_SEARCH=${INCS}; done
	# Then build all the rest
	LD_LIBRARY_PATH=$(DESTDIR)/lib:$(LIBDIR)/fortran/$(F77):$(CURDIR)/shared $(MAKE) Everything \
		DEV_SYS_LIBS=$(EXTRA_LIBS) INCSEARCH=${INCS} INC_SEARCH=${INCS} LD_REL="ld -zmuldefs" LIBSEARCH=-L$(LIBDIR)/hdf5/serial/lib
	mv $(DESTDIR)/staticlibs/* $(DESTDIR)/lib

override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/libncarg-dev/$(LIBDIR)/ncarg
	# TODO: These may not be present on mips64el. 
	mkdir -p debian/libncarg-data/usr/share/ncarg/nug
	[ -d $(DESTDIR)/lib/ncarg/fontcaps ]   && cp -a $(DESTDIR)/lib/ncarg/fontcaps debian/libncarg-data/usr/share/ncarg || true
	[ -d $(DESTDIR)/lib/ncarg/nclex/nug  ] && cp -a $(DESTDIR)/lib/ncarg/nclex/nug debian/libncarg-data/usr/share/ncarg/nug || true
	cp $(DESTDIR)/lib/*.a debian/libncarg-dev/$(LIBDIR)/ncarg
	find debian -name '*.ksh' -exec chmod +x {} \;
	# Sanitise paths for bit reproducibility
	for f in $(DESTDIR)/usr/bin/ncargcc \
		 $(DESTDIR)/usr/bin/ncargf77 \
		 $(DESTDIR)/usr/bin/ncargf90 \
		 $(DESTDIR)/usr/bin/nhlcc \
		 $(DESTDIR)/usr/bin/nhlf77 \
		 $(DESTDIR)/usr/bin/nhlf90 ; do cat $$f | \
		 sed -e 's%${CURDIR}%/build/ncl-ncarg%g'  \
                        > debian/tmpff ; \
		mv debian/tmpff $$f ; \
		done

override_dh_auto_clean:
	find . -name '*.so.1' -delete
	find . -type l -delete
	find . -name '*.o' -delete
	rm -f ncarg.pc config/Site.local.* config/DEBIAN
ifneq ($(wildcard config/LINUX.ORIG),)
	mv config/LINUX.ORIG config/LINUX
endif

ifneq (,$(filter $(DEB_BUILD_ARCH),mipsel alpha))
override_dh_dwz:
	@echo bypass dwz that causes build failues
endif
